package edu;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import owrti.util.CDRCoderEncoder;

public class RectElement implements Element {
  Rectangle bounds;
  int tX=0;
  int tY=0;
  Color color;
  int objectID = -1;
  WB  network;
  short classId = -1;
  
  RectElement(int _objectID) 
  { objectID=_objectID; bounds = new Rectangle (10, 10, 10, 10); color=Color.red; }

  RectElement (int x, int y, int w, int h, Color c) {
    bounds = new Rectangle (x, y, w, h);
    color = c;
  }

  RectElement (int x, int y, int w, int h, Color c,int _objectID, int _tX, int _tY) 
  {
    bounds = new Rectangle (x, y, w, h);
    color = c;
    tX=_tX;
    tY=_tY;
    objectID=_objectID;
  }

  public Rectangle getBounds () {
    return bounds;
  }

  /**
  */
  public Element 
  getTranslated (int dX, int dY) 
  {
    //Element ret = new RectElement (bounds.x + dX, bounds.y + dY, bounds.width, bounds.height, color,objectID,dX,dY);
    Element ret = new RectElement (bounds.x + dX, bounds.y + dY, bounds.width, bounds.height, color);
    tX=dX;
    tY=dY;

    
    if(network!=null)
    {
       network.sendObjectAttribute(objectID,"transx",CDRCoderEncoder.toByte(tX));
       network.sendObjectAttribute(objectID,"transy",CDRCoderEncoder.toByte(tY));
    } else System.out.println("network is NULL!");

    return ret;
  }

  public void
  paint (Graphics g)
  {
    g.setColor (color);
    if ((bounds.width == 1) && (bounds.height == 1))
      g.drawLine (bounds.x+tX, bounds.y+tY, bounds.x, bounds.y);
    else
      g.drawRect (bounds.x+tX, bounds.y+tY, bounds.width - 1, bounds.height - 1);
  }

  public void setCord(int x, int y, int w, int h) 
  {
    bounds = new Rectangle (x, y, w, h);
    
    System.out.println("setCord of RectElement");
    network.sendObjectAttribute(objectID,"x",CDRCoderEncoder.toByte(x));
    network.sendObjectAttribute(objectID,"y",CDRCoderEncoder.toByte(y));
    network.sendObjectAttribute(objectID,"width",CDRCoderEncoder.toByte(w));
    network.sendObjectAttribute(objectID,"height",CDRCoderEncoder.toByte(h));

  }// end of setCord()  

  public void setObjectID(int objID) { objectID= objID; };

  public void setNetwork(Network _net) { network=(WB)_net; }

  UpdateListener reflect=null;

  public void    
  setUpdateListener(UpdateListener lis) { reflect=lis; }

  /**
  */
  public boolean 
  updateAttributes(RTIcap.AttributeHandleValuePair[] theAttributes)
  {
    boolean changed=false;
    if(network==null)   
       System.out.println(" in updateAttributes : network is NULL");

    if( network!=null )
    {
      System.out.println(" in updateAttributes ");
      for(int i=0;i<theAttributes.length;i++)
      {
        if( theAttributes[i].handle == network.getObjectAtributeTypeId("Rectangle","x") )
             { bounds.x=CDRCoderEncoder.extractInt(theAttributes[i].value);
               changed=true;
             }
        else if( theAttributes[i].handle == network.getObjectAtributeTypeId("Rectangle","y") )
             {
               bounds.y=CDRCoderEncoder.extractInt(theAttributes[i].value);
               changed=true;
             }
        else if( theAttributes[i].handle == network.getObjectAtributeTypeId("Rectangle","width") )
             {
               bounds.width=CDRCoderEncoder.extractInt(theAttributes[i].value);
               changed=true;
             }

        else if( theAttributes[i].handle == network.getObjectAtributeTypeId("Rectangle","height") )
             {
               bounds.height=CDRCoderEncoder.extractInt(theAttributes[i].value);
               changed=true;
             }

        else if( theAttributes[i].handle == network.getObjectAtributeTypeId("Rectangle","transx") )
             {
               tX =CDRCoderEncoder.extractInt(theAttributes[i].value);
               changed=true;
             }

        else if( theAttributes[i].handle == network.getObjectAtributeTypeId("Rectangle","transy") )
             {
               tY =CDRCoderEncoder.extractInt(theAttributes[i].value);
               changed=true;
             }


     }// end of for

    }// end of

    if( changed ) System.out.println(" CHANGED!!! in updateAttributes ");
    if( changed && reflect!=null ) 
        reflect.updateOccurred(new UpdateEvent(this));

    return changed ;

  }//end

}
