package edu;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
*
* @author Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*
*/
public class 
Select extends Component implements Tool, UpdateListener 
{

  ObservableList elements;
  WBContainer    renderer;
  WB             network;

  public Select () 
  { enableEvents (AWTEvent.MOUSE_EVENT_MASK | AWTEvent.MOUSE_MOTION_EVENT_MASK); }

  public void setNetwork (WB _ren) { network = _ren; }

  public void setDisplay (WBContainer _ren)
  { renderer = _ren; elements =renderer.getElements(); }

  public void setDisplayList (ObservableList l)
  {
    elements = l;
    elements.addUpdateListener (this);
  }

  public Component getDisplay () { return this; }

  public Component getControls () {
    LWContainer controls = new LWContainer ();
    controls.setLayout (new BorderLayout ());
    controls.add ("North", new Label ("Select Tool", Label.CENTER));
    return controls;
  }

  public void dispose () {
    elements.removeUpdateListener (this);
  }

  public void 
  updateOccurred (UpdateEvent e) 
  { 
    //if (selected != null) { selected = null; repaint (); }
  }

  Element selected;
  int x0, y0, x1, y1;
  boolean isSelected = false;
    
  public void processEvent (AWTEvent e) {
    super.processEvent (e);
    if (e instanceof MouseEvent) {
      MouseEvent m = (MouseEvent) e;
      switch (m.getID ()) {
        case MouseEvent.MOUSE_PRESSED:
          System.out.println("MouseEvent.MOUSE_PRESSED!"); 
          Element oSelected = selected;
          x0 = x1 = m.getX ();
          y0 = y1 = m.getY ();
          selected = null;
          //isSelected=false;
          Enumeration els = elements.elements ();
          //Enumeration els = renderer.getElements().elements ();
          if ( !els.hasMoreElements() ) 
               System.out.println("There is nothing to pick!"); 
          while (els.hasMoreElements ()) {
            Element el = (Element) els.nextElement ();
            if ((el != null) && el.getBounds ().contains (x0, y0))
            { selected = el; isSelected=true; }
          }
          if (selected != oSelected) repaint ();
          //if (selected != oSelected) repaint ();
          break;
        case MouseEvent.MOUSE_DRAGGED:
          if (selected != null) {
          //if ( isSelected ) {
            x1 = m.getX ();
            y1 = m.getY ();
            selected.getTranslated(x1-x0,y1-y0); 
            if(renderer!=null) renderer.repaint();//repaint ();
          }
          break;
        case MouseEvent.MOUSE_RELEASED:
          //if ( isSelected ) {
          if (selected != null) {
            x1 = m.getX ();
            y1 = m.getY ();
            //selected.getTranslated(x1-x0,y1-y0); 
            elements.replaceElementAtEnd (selected, selected.getTranslated (x1 - x0, y1 - y0));
            selected = null;
            //isSelected=false;
            if(renderer!=null) renderer.repaint();//repaint ();
          } else System.out.println(" selected is NULL!");
          break;
      }
    }
  }

  public void paint (Graphics g) {
    if (selected != null) {
      Rectangle r = selected.getBounds ();
      g.setColor (Color.red);
      g.drawRect (r.x - 1 + x1 - x0, r.y - 1 + y1 - y0, r.width + 1, r.height + 1);
    }
  }
}
