package edu;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.
import owrti.util.*;

/**
*
* @author Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*
*/
public class WB extends JFrame implements ActionListener, Network
{
   java.lang.Object guard = new java.lang.Object();
  String  fedName = "Whiteboard";
  String  fedCnfName = fedName+".fed";
   
  RTIcap.RTIambassador rtiAmb;
  PrintWriter myLog;


  AppletProps parent;
  ObservableList contents;
  Hashtable ctrlImages, ctrlClasses;
  JPanel infoHolder;
  WBContainer display;

  Tool currentTool;

  JMenuItem exitItem;
  String ExitTxt = "Exit";
  String myName = "WBC";

  boolean       advanceGranted = false;
  double        currentTime = 0.0; 
  double        timeStep = 5.0; 
  double        requestTime ; 
  boolean       isConnected = false;
   short   federateId;

  public WB (AppletProps a, RTIcap.RTIambassador _rtiAmb)
  {
    super ("Whiteboard");
    rtiAmb = _rtiAmb;
    Date aDate = new Date();
    myName = "WBC"+aDate; myName = myName.replace(' ','_');

    try 
    { myLog = new PrintWriter(new FileWriter("hello.log"),true);
    } catch( java.io.IOException ioe) {}

    JMenuBar menuBar;
    JMenu menu, submenu;
    JMenuItem menuItem;
    JCheckBoxMenuItem cbMenuItem;
    JRadioButtonMenuItem rbMenuItem;

     addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {

                WB.this.doExit();
            }
     });

     //Create the menu bar.
     menuBar = new JMenuBar();
     setJMenuBar(menuBar);

     //Build the first menu.
     menu = new JMenu("Menu");
     menuBar.add(menu);

     //openItem = new JMenuItem(OpenURL);
     exitItem = new JMenuItem(ExitTxt);
     //menu.add(openItem);
     //menu.addSeparator();
     menu.add(exitItem);
     //openItem.addActionListener(this);
     exitItem.addActionListener(this);

    //enableEvents (AWTEvent.WINDOW_EVENT_MASK);
    parent = a;
    contents = new ObservableList ();

    display = new WBContainer (contents, new Dimension (256, 256));
    display.setLayout (new BorderLayout ());
    display.setBackground(Color.white);

    getContentPane().add ("Center", display);

    //LWContainer ctrlHolder = new LWContainer (), ctrls = new LWContainer ();
    JPanel ctrlHolder = new JPanel ();
    JPanel ctrls      = new JPanel ();
    
    getContentPane().add ("West", ctrlHolder);

    ctrlHolder.setLayout (new FlowLayout (FlowLayout.LEFT, 0, 0));
    ctrlHolder.add (ctrls);
    ctrls.setLayout (new GridLayout (0, 1, 0, 2));
    ctrlImages = new Hashtable ();
    ctrlClasses = new Hashtable ();

    try {
      URL u = new URL (parent.getCodeBase (), "config.txt");
      BufferedReader r = new BufferedReader (new InputStreamReader (u.openStream (), "latin1"));
      String line;
     
      while ((line = r.readLine ()) != null)
      {
        StringTokenizer t = new StringTokenizer (line, ",");
        String name = t.nextToken (), imageName = t.nextToken (), className = t.nextToken ();
        ImageIcon theImage = new ImageIcon(new URL(parent.getCodeBase ()+imageName));
        JButton button = new JButton(name,theImage);
        ctrls.add (button);
        ctrlImages.put (name, theImage);

        try
        { ctrlClasses.put (name, Class.forName (className));
        } catch (ClassNotFoundException ex)
          { button.setEnabled (false); }

        button.addActionListener (this);

      }// end of while

      r.close ();

    } catch (IOException ex)
      { ex.printStackTrace (); }
      //catch (MalformedURLException ex1)
      //{ ex1.printStackTrace (); }

    
    infoHolder = new JPanel ();
    infoHolder.setLayout (new BorderLayout ());

    JButton logo = new JButton("logo", new ImageIcon("middle.gif") );
    logo.setEnabled (false);
    infoHolder.add ( logo , BorderLayout.WEST);
    getContentPane().add (infoHolder,BorderLayout.SOUTH);
    pack ();
    setVisible(true);

    doRealyConnect();

  }// end of CONSTRUCTOR

  protected void processWindowEvent (WindowEvent e) {
    super.processWindowEvent (e);
    if (e.getID () == WindowEvent.WINDOW_CLOSING)
      setVisible (false);
  }

  protected void processEvent (AWTEvent e) {
    if ((e instanceof ActionEvent) && (e.getSource () instanceof AppletProps)) {
      init ((AppletProps) e.getSource ());
    } else super.processEvent (e);
  }



  void init(AppletProps a ) { }

  void init1 (AppletProps a ) {
    parent = a;
    contents = new ObservableList ();

    display = new WBContainer (contents, new Dimension (256, 256));
    display.setLayout (new BorderLayout ());

    getContentPane().add (display, BorderLayout.CENTER);

    JPanel ctrlHolder = new JPanel ();
    JPanel ctrls      = new JPanel ();
    
    getContentPane().add ( ctrlHolder, BorderLayout.WEST);

    ctrlHolder.setLayout (new FlowLayout (FlowLayout.LEFT, 0, 0));
    ctrlHolder.add (ctrls);
    ctrls.setLayout (new GridLayout (0, 1, 0, 2));
    ctrlImages = new Hashtable ();
    ctrlClasses = new Hashtable ();

    try {
      URL u = new URL (parent.getCodeBase (), "config.txt");
      BufferedReader r = new BufferedReader (new InputStreamReader (u.openStream (), "latin1"));
      String line;
     
      while ((line = r.readLine ()) != null)
      {
        StringTokenizer t = new StringTokenizer (line, ",");
        String name = t.nextToken (), imageName = t.nextToken (), className = t.nextToken ();
        //Image theImage = parent.getImage (parent.getCodeBase (), imageName);
        
        //LWImageButton button = new LWImageButton (name, theImage, new Dimension (64, 64));
        ImageIcon theImage = new ImageIcon(new URL(parent.getCodeBase ()+imageName));
        JButton button = new JButton(name,theImage);
        ctrls.add (button);
        ctrlImages.put (name, theImage);

        try
        { ctrlClasses.put (name, Class.forName (className));
        } catch (ClassNotFoundException ex)
          { button.setEnabled (false); }

        button.addActionListener (this);

      }// end of while

      r.close ();

    } catch (IOException ex)
      { ex.printStackTrace (); }
      //catch (MalformedURLException ex1)
      //{ ex1.printStackTrace (); }

    
    infoHolder = new JPanel ();
    infoHolder.setLayout (new BorderLayout ());

    JButton logo = new JButton("logo", new ImageIcon("middle.gif") );
    logo.setEnabled (false);
    infoHolder.add ( logo , BorderLayout.WEST);
    getContentPane().add (infoHolder,BorderLayout.SOUTH);
    pack ();
    setVisible(true);
  }

  /**
  * ActionListener interface to collect the user events.
  * @param e ActionEvent
  */
  public void 
  actionPerformed (ActionEvent e)
  {
    
    if( e.getSource() instanceof JMenuItem)
    {
     JMenuItem source = (JMenuItem)(e.getSource());
     if( source.getText().equals(ExitTxt)) doExit();
     //else if( source.getText().equals(OpenURL) ) openURLProcess();
    }
    else
    {

    ImageIcon theImage = (ImageIcon) ctrlImages.get (e.getActionCommand ());
    Class theClass = (Class) ctrlClasses.get (e.getActionCommand ());
    System.out.println( e.getActionCommand ()+" selected! ");
    try {
      if (currentTool != null) {
        currentTool.dispose ();
        currentTool = null;
      }
      currentTool = (Tool) theClass.newInstance ();
      //currentTool.setDisplayList (contents);
      currentTool.setDisplay (display);
      currentTool.setNetwork (this);

      JButton button = new JButton(e.getActionCommand (), theImage);
      button.setEnabled (false);
      infoHolder.removeAll ();
      infoHolder.add ("West", button);
      infoHolder.add ("Center", currentTool.getControls ());
      infoHolder.validate ();
      display.setTool(currentTool);
      //display.removeAll ();
      //display.add ("Center", currentTool.getDisplay ());
      //display.validate ();

    } catch (InstantiationException ex)
      { ex.printStackTrace (); } 
      catch (IllegalAccessException ex)
      { ex.printStackTrace (); }
    }
  }

   /**
   *
   * Gets the RTTI (Meta-Object Protocol MOP) handles.
   *
   * Ask RTI about the class indentifier of each object, attribute, 
   * interaction and parameter. So that we can define, subscribe, publish,
   * and interpret these attributes/objects.
   *
   */
   boolean getRtiIds()
   {
      boolean ret = false;

      if( rtiAmb != null )
      {
         ObjRecord aRec = null;
         short objId = -1;
         int   attId = -1;

         try
         {
           objId = rtiAmb.getObjectClassHandle("Rectangle");
           aRec = new ObjRecord("Rectangle",objId);  
           objRecs.put("Rectangle",aRec);
           cIDToobjRecs.put( new Integer(objId), aRec);

         } catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( aRec!=null )
         try
         {
           attId = rtiAmb.getAttributeHandle("x",objId );
           aRec.addAttributeId("x",attId);
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( aRec!=null )
         try
         {
           attId = rtiAmb.getAttributeHandle("y",objId );
           aRec.addAttributeId("y",attId);
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( aRec!=null )
         try
         {
           attId = rtiAmb.getAttributeHandle("transx",objId );
           aRec.addAttributeId("transx",attId);
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( aRec!=null )
         try
         {
           attId = rtiAmb.getAttributeHandle("transy",objId );
           aRec.addAttributeId("transy",attId);
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( aRec!=null )
         try
         {
           attId = rtiAmb.getAttributeHandle("width",objId );
           aRec.addAttributeId("width",attId);
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( aRec!=null )
         try
         {
           attId = rtiAmb.getAttributeHandle("height",objId );
           aRec.addAttributeId("height",attId); 
           ret = true;
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         /*try
         {
          chatterObjAttrLastSayTypeId = rtiAmb.getAttributeHandle(chatterObjAttrLastSay,chatterObjectTypeId );
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}


         try
         { 
           chatterTypeId = rtiAmb.getInteractionClassHandle(chatterTypeStr);
         } catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         try
         { 
           chatterMsgTypeId = 
                  rtiAmb.getParameterHandle(chatterMsgTypeStr,chatterTypeId);
           ret = true;
         } catch( RTIcap.InteractionClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}*/


      }// end of if
  
      return ret;

   }// end of getRtiIds()

   /**
   *
   * Describe our interest for publishing objects and attributes.
   * Describe our interest for receiving objects and attributes.
   * Describe our interest for publishing interations and parameters.
   * Describe our interest for receiving interations and parameters.
   *
   */
   boolean publishSubscribe()
   {

      boolean ret = false;

      if( rtiAmb != null )
      {
         ObjRecord aRec  = (ObjRecord) objRecs.get("Rectangle");
         short[] myAttributes = new short[6];
         myAttributes[0] = (short) aRec.getAttributeId("x");
         myAttributes[1] = (short) aRec.getAttributeId("y");
         myAttributes[2] = (short) aRec.getAttributeId("width");
         myAttributes[3] = (short) aRec.getAttributeId("height");
         myAttributes[4] = (short) aRec.getAttributeId("transx");
         myAttributes[5] = (short) aRec.getAttributeId("transy");

         try
         {
             rtiAmb.subscribeObjectClassAttributes( (short)aRec.getClassId(), myAttributes , RTIcap._Boolean.RTI_TRUE);
           } catch( RTIcap.ObjectClassNotDefined  flsc)
             {
               System.out.println(" exception ObjectClassNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.AttributeNotDefined  fnem)
             {
               System.out.println(" exception AttributeNotDefined! ");
               System.exit(1);
             }
             catch( RTIcap.FederateNotExecutionMember  fnem)
             {
               System.out.println(" exception FederateNotExecutionMember! ");
               System.exit(1);
             }
             catch( RTIcap.RTIinternalError  ie)
             {
               System.out.println(" exception RTIinternalError! ");
               System.exit(1);
             }
             catch( RTIcap.RestoreInProgress  rip)
             {
               System.out.println(" exception RestoreInProgress! ");
               System.exit(1);
             }
             catch( RTIcap.SaveInProgress  sip)
             {
               System.out.println(" exception SaveInProgress! ");
               System.exit(1);
             }


         try
         {
            rtiAmb.publishObjectClass( (short)aRec.getClassId(), myAttributes );
            ret = true;
         } catch( RTIcap.ObjectClassNotDefined  flsc)
           {
               System.out.println(" exception ObjectClassNotDefined! ");
               System.exit(1);
           }
           catch( RTIcap.AttributeNotDefined  fnem)
           {
               System.out.println(" exception AttributeNotDefined! ");
               System.exit(1);
           }
           catch( RTIcap.FederateNotExecutionMember  fnem)
           {
               System.out.println(" exception FederateNotExecutionMember! ");
               System.exit(1);
           }
           catch( RTIcap.RTIinternalError  ie)
           {
              System.out.println(" exception RTIinternalError! ");
               System.exit(1);
           }
           catch( RTIcap.RestoreInProgress  rip)
           {
               System.out.println(" exception RestoreInProgress! ");
               System.exit(1);
           }
           catch( RTIcap.SaveInProgress  sip)
           {
               System.out.println(" exception SaveInProgress! ");
               System.exit(1);
           }

         /*try
         {
           rtiAmb.subscribeInteractionClass( chatterTypeId, RTIcap._Boolean.RTI_TRUE);
         } catch( RTIcap.FederateLoggingServiceCalls  flsc) {}
           catch( RTIcap.FederateNotExecutionMember  fnem) {}
           catch( RTIcap.RTIinternalError  ie) {}
           catch( RTIcap.RestoreInProgress  rip) {}
           catch( RTIcap.InteractionClassNotDefined  icnd) {}
           catch( RTIcap.SaveInProgress  sip) {}

         try
         {
           rtiAmb.publishInteractionClass( chatterTypeId );
           ret = true;
         } catch( RTIcap.FederateNotExecutionMember fnem) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.InteractionClassNotDefined icnd) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RTIinternalError ie) {}*/

      }// end of if

      return ret;

   }// end of publishSubscribe()

   /**
   * 
   * We want to join the Federation but we do not know its ID and
   * whether it is on. Therefore, we first try to create this Federation.
   * If this federation is  already exists, we will receive the exception.
   * If not, it will be created for us.
   * Then we need to join this execution and get ourself a federate id.
   * 
   */
   boolean joinFederationExecution(RTIcap.FederateAmbassador fedAmb)
   {

      boolean ret = false;

      if( rtiAmb != null )
      {

         try {
           rtiAmb.createFederationExecution(fedName,fedCnfName);
         } catch( RTIcap.FederationExecutionAlreadyExists icnd) {}
           catch( RTIcap.RTIinternalError ie) {}

         try
         {
            federateId = rtiAmb.joinFederationExecution(myName,fedName,fedAmb);
            ret = true;
         } catch( RTIcap.FederateAlreadyExecutionMember fnem) {}
           catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.CouldNotOpenFED fnem) {}
           catch( RTIcap.ErrorReadingFED fnem) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

      return ret;

   }// end of joinFederationExecution() 

   /**
   *
   * To register a new object to the RTI
   *   1. Get an ObjectId for the "Rectangle" object type. This will define
   *      a new instane for us.
   *   2. Define our simulation object(myCountry) with return information
   *      so that SimCountry object knows what its ObjectID in this
   *      federation.
   *
   */
   public boolean registerRti(Element ele)
   {
      boolean ret = false;
      int     objInstanceId;

      if( rtiAmb != null )
      {

         short objID = getObjectClassTypeId("Rectangle");
         if( objID!=-1 )
         try
         {
             objInstanceId = rtiAmb.registerObjectInstance(objID);

             ele.setObjectID(objInstanceId);
             ele.setNetwork(this);

             if(display!=null) display.addElement(ele);

             // register ObjectID ==> Element
             add(objInstanceId,ele);

             // register ObjectID ==> RTIClassId
             add(objInstanceId,objID);

             ret = true;

         } catch( RTIcap.ObjectClassNotDefined sip) {}
           catch( RTIcap.ObjectClassNotPublished sip) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.FederateNotExecutionMember icnd) {}
           catch( RTIcap.RTIinternalError ie) {} 

         tickRTI(2);

      }// end of if

      return ret;

   }// end of registerRti()

  /**
  *
  * Before we leave the Federation
  *  1. Delete all the object that we are suppose(promised) to simulate.
  *  2. resign from the federation.
  *  3. Try to destroy the federation execution. Note that if there 
  *     are still federates in the Federation, the federation execution
  *     won't be stopped. Only, we resign it. 
  *
  */
  void leaveFederationExecution()
  {

      if( rtiAmb != null )
      {

         try 
         {
           rtiAmb.resignFederationExecution(RTIcap.ResignAction.DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
         } catch( RTIcap.InvalidResignAction ie) {}
           catch( RTIcap.FederateOwnsAttributes ie) {}
           catch( RTIcap.FederateNotExecutionMember ie) {}
           catch( RTIcap.RTIinternalError ie) {}

         try 
         {
           rtiAmb.destroyFederationExecution(fedName);
         } catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.FederatesCurrentlyJoined ie) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

   }// end of leaveFederationExecution() 


   /**
   *
   * Ticks the RTIambassador. This will cause the delivery of waiting 
   * events in the Receive Order Queue.
   *
   */
   public void
   tickRTI( long sleepTime )
   {
      //while( !isTimeAdvanceGranted() )
      //{
         try { rtiAmb.tick( ); } 
         catch( RTIcap.RTIinternalError aa ) {}

        // mySleep(2);

      //}// end of while() 

   }// end of tickRTI()

  /**
  * Connects to the Federation Execution
  */
  void doRealyConnect()
  {
      int count = 0;

      myLog.println(" before ChatFedAmb definition ");

      /*******************************************************************/
      /** Define FederateAmbassador for HelloWorld. This objects serves  */
      /** as a callback mechanism so that RTI can bring us the necessary */ 
      /** events.                                                        */
      /*******************************************************************/
      WBFedAmb fedAmb = new WBFedAmb(this);
      //orb.connect(fedAmb);
      org.omg.CORBA.ORB.init().connect(fedAmb);

      myLog.println(" ChatFedAmb is defined ");
      
      /************************************************************/
      /** Create FederationExecution, get RTI id of the objects,  */
      /** attributes, interactions, and parameters.               */
      /** Define interest for Subscription/Publishing.            */
      /** Define my simulated object.                             */
      /************************************************************/
      if( joinFederationExecution(fedAmb) && getRtiIds() && 
          publishSubscribe() ) //&& registerRti() )
      {
        
        /*********************************************************************/
        /** TimeConstrained : we want to receive timestamped events in order */
        /*********************************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeConstrained( );
        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeConstrainedPending aa ) {}
          catch( RTIcap.TimeConstrainedAlreadyEnabled aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /***************************************************/
        /** Tick RTI to get timeConstrainedEnabled message */
        /***************************************************/
        tickRTI(2);

        /**********************************************************/
        /** TimeRegulating : We want to vote for time advancement */
        /**********************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeRegulation( currentTime, 5.0 );

        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeRegulationPending aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.TimeRegulationAlreadyEnabled aa ) {}
          catch( RTIcap.InvalidLookahead aa ) {}
          catch( RTIcap.InvalidFederationTime aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /**************************************************/
        /** Tick RTI to get timeRegulationEnabled message */
        /**************************************************/
        tickRTI(2);

        try
        { 
           rtiAmb.enableAsynchronousDelivery( );
           isConnected = true;

        } catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.AsynchronousDeliveryAlreadyEnabled aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

      }// end of if 

  }// end of doRealyConnect()

  /**
  * Displays the error message in the warning window.
  * @param mess Error message.
  */
  void giveError(String mess)
  {
     JOptionPane.showMessageDialog( this, "Sorry!"+"\n"+mess,"",
                                    JOptionPane.ERROR_MESSAGE);

  }// end of giveError()

  /**
  * Move the frame back, and destroy the execution.
  */
  void doExit()
  {
     toBack();
     if(isConnected) leaveFederationExecution();
     System.exit(0);

  }// end of doExit()

  Hashtable objRecs = new Hashtable();
  Hashtable interRecs = new Hashtable();
  
  Hashtable cIDToobjRecs = new Hashtable();
  Hashtable cIDTointerRecs = new Hashtable();

  /**
  * @return 
  */
  public short getObjectClassTypeId(String className) 
  { 
    short ret = -1;
    ObjRecord oRec = (ObjRecord)objRecs.get(className);
    if( oRec!=null ) ret = (short) oRec.getClassId();
    return ret;

  }// end of getObjectClassTypeId()

  /**
  * @return 
  */
  public ObjRecord getObjectRec(short classRtiId) 
  { 
    return (ObjRecord)cIDToobjRecs.get(new Integer(classRtiId));

  }// end of getObjectRec()

  /**
  * @return 
  */
  public short getObjectAtributeTypeId(String className, String attName ) 
  { 
    short ret = -1;
    ObjRecord oRec = (ObjRecord)objRecs.get(className);
    if( oRec!=null ) ret = (short) oRec.getAttributeId(attName);
    return ret;

  }// end of getObjectAtributeTypeId()

  /**
  * @return 
  */
  public short getInteractionClassTypeId(String className) 
  { 
    short ret = -1;
    InterRecord oRec = (InterRecord)interRecs.get(className);
    if( oRec!=null ) ret = (short) oRec.getClassId();
    return ret;

  }// end of getInteractionClassTypeId()

  /**
  * @return 
  */
  public short getInteractionParameterTypeId(String className, String attName ) 
  { 
    short ret = -1;
    InterRecord oRec = (InterRecord)interRecs.get(className);
    if( oRec!=null ) ret = (short) oRec.getParameterId(attName);
    return ret;

  }// end of getInteractionParameterTypeId()

  Hashtable objIDToElement = new Hashtable();
  Hashtable objIDToClassId = new Hashtable();

   /**
   * Mainly used for registering Remote Objects.
   */
   public void
   addObject( int objID, short classRtiId )
   {
      
      Element cnt = get( objID );

      if( cnt == null )
      { 
         Element newCandidate = null;

         if( classRtiId==getObjectClassTypeId("Rectangle"))  
             newCandidate = new RectElement(objID);

         if( newCandidate!=null )
         { 
           add(objID, newCandidate ) ;
           objIDToClassId.put( new Integer(objID), new Integer(classRtiId) );
           if(display!=null) display.addElement(newCandidate);
           newCandidate.setNetwork(this);
           newCandidate.setUpdateListener(display);

         }// end of if

      }// end of if

   }// end of add()

   /**
   * Mainly used for removing Remote Objects.
   */
   public void
   removeObject( int objID )
   {
      Element cnt = get( objID );

      if( cnt != null )
      { 
        objIDToClassId.remove(new Integer(objID));
        objIDToElement.remove(new Integer(objID));
        if(display!=null) display.removeElement(cnt);
        cnt=null;

      }// end of if

   }// end of add()

   /**
   */
   public Element
   get( int objID)
   {
      System.out.println(" In get("+objID+") ");
      return (Element)objIDToElement.get(new Integer(objID));

   }// end of add()

   /**
   */
   public void
   add( int objID, Element newCandidate )
   {
      Element cnt = (Element) objIDToElement.get( new Integer(objID) );
      if( cnt == null ) objIDToElement.put( new Integer(objID), newCandidate ) ;

   }// end of add()

   /**
   */
   public void
   add( int objID, short classId )
   {
      Integer cnt = (Integer) objIDToClassId.get( new Integer(objID) );
      if( cnt == null ) 
          objIDToClassId.put( new Integer(objID), new Integer(classId) ) ;

   }// end of add()

   /**
   */
   public void
   remove( int objID )
   {
      Element cnt = (Element) objIDToElement.get( new Integer(objID) );
      if( cnt != null ) objIDToElement.remove( new Integer(objID) );
   }// end of remove()

   /**
   */
   public Enumeration
   getAllEntities()
   {
      return objIDToElement.elements();

   }// end of getAllEntities()

   /**
   */
   public Element
   getEntity( int objID )
   {
      return (Element) objIDToElement.get( new Integer(objID) );
   }// end of getEntity()

   /**
   */
   public void sendObjectAttribute(int objID, String attName, byte[] value)
   {
      Integer classId = (Integer) objIDToClassId.get(new Integer(objID));
      System.out.println(" in sendObjectAttribute("+objID+","+attName+")");

      if( classId==null ) System.out.println("classId is not knon!");
      if( rtiAmb==null ) System.out.println("rtiAmb is NULL!");

      if( classId!=null && rtiAmb!=null )
      {
         System.out.println(" in sendObjectAttribute("+objID+","+attName+")");

         int iclassId = classId.intValue();

         ObjRecord oRec = getObjectRec((short)iclassId);

         if( oRec!=null )
         {
            RTIcap.AttributeHandleValuePair[] eles = new RTIcap.AttributeHandleValuePair[1];

            eles[0] = new RTIcap.AttributeHandleValuePair((short)oRec.getAttributeId(attName),value);
            try
            {
              rtiAmb.updateAttributeValues(objID,eles,attName);

              /******************************************************/
              /** Since we sent this update, we no longer required  */
              /** to send it again. Unless we are asked to do so    */
              /** ( Look at provideAttributesUpdates )              */
              /******************************************************/
              //resetNameChanged();

            } catch (RTIcap.ObjectNotKnown onk) {}
              catch (RTIcap.AttributeNotDefined onk) {}
              catch (RTIcap.AttributeNotOwned onk) {}
              catch (RTIcap.FederateNotExecutionMember onk) {}
              catch (RTIcap.SaveInProgress onk) {}
              catch (RTIcap.RestoreInProgress onk) {}
              catch (RTIcap.RTIinternalError onk) {}

 
         } else System.out.println(" Could not find Object Class Record"); 

      }// end of if
     
   }// end of sendObjectAttribute()

   /**
   */
   public void
   resetTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = false; } 
   }// end of resetTimeAdvanceGranted()

   /**
   * This method will be invoked by HwFededarateAmbassador object whenever
   *
   *   timeAdvanceGrant 
   *   timeConstrainedEnabled
   *   timeRegulationEnabled
   *
   * messages received.
   *
   */
   public void
   setTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = true; } 
   }// end of setTimeAdvanceGranted()

   /**
   */
   public boolean
   isTimeAdvanceGranted()
   { return advanceGranted ; 
   }// end of isTimeAdvanceGranted()

   /**
   */
   public void
   setCurrentTime( double _newTime)
   { 
     if( _newTime >= currentTime ) currentTime = _newTime;

   }// end of setCurrentTime()

}

